// D import file generated from 'gl3n/aabb.d'
module gl3n.aabb;
private 
{
	import gl3n.linalg : Vector, vec3;
	import gl3n.math : almost_equal;
}
struct AABBT(type)
{
	alias at = type;
	alias vec3 = Vector!(at, 3);
	vec3 min = vec3(0.00000F, 0.00000F, 0.00000F);
	vec3 max = vec3(0.00000F, 0.00000F, 0.00000F);
	nothrow pure @safe 
	{
		this(vec3 min, vec3 max)
		{
			this.min = min;
			this.max = max;
		}
		static AABBT from_points(vec3[] points)
		{
			AABBT res;
			if (points.length == 0)
			{
				return res;
			}
			res.min = points[0];
			res.max = points[0];
			foreach (v; points[1..$])
			{
				res.expand(v);
			}
			return res;
		}
		void expand(AABBT b)
		{
			if (min.x > b.min.x)
				min.x = b.min.x;
			if (min.y > b.min.y)
				min.y = b.min.y;
			if (min.z > b.min.z)
				min.z = b.min.z;
			if (max.x < b.max.x)
				max.x = b.max.x;
			if (max.y < b.max.y)
				max.y = b.max.y;
			if (max.z < b.max.z)
				max.z = b.max.z;
		}
		void expand(vec3 v)
		{
			if (v.x > max.x)
				max.x = v.x;
			if (v.y > max.y)
				max.y = v.y;
			if (v.z > max.z)
				max.z = v.z;
			if (v.x < min.x)
				min.x = v.x;
			if (v.y < min.y)
				min.y = v.y;
			if (v.z < min.z)
				min.z = v.z;
		}
		const bool intersects(AABBT box)
		{
			return min.x < box.max.x && (max.x > box.min.x) && (min.y < box.max.y && (max.y > box.min.y)) && (min.z < box.max.z && (max.z > box.min.z));
		}
		const @property vec3 extent()
		{
			return max - min;
		}
		const @property vec3 half_extent()
		{
			return 0.5 * (max - min);
		}
		const @property at area()
		{
			vec3 e = extent;
			return 2.00000 * (e.x * e.y + e.x * e.z + e.y * e.z);
		}
		const @property vec3 center()
		{
			return 0.5 * (max + min);
		}
		const @property vec3[] vertices()
		{
			return [vec3(min.x, min.y, min.z), vec3(min.x, min.y, max.z), vec3(min.x, max.y, min.z), vec3(min.x, max.y, max.z), vec3(max.x, min.y, min.z), vec3(max.x, min.y, max.z), vec3(max.x, max.y, min.z), vec3(max.x, max.y, max.z)];
		}
		const bool opEquals(AABBT other)
		{
			return other.min == min && (other.max == max);
		}
	}
}
alias AABB = AABBT!float;
