// D import file generated from 'gl3n/ext/matrixstack.d'
module gl3n.ext.matrixstack;
private import gl3n.util : is_matrix;
struct MatrixStack(T) if (is_matrix!T)
{
	alias Matrix = T;
	Matrix top = Matrix.identity;
	private Matrix[] stack;
	private size_t _top_pos = 0;
	alias top this;
size_t realloc_interval = 8;
	deprecated("Use matrixStack() instead.") @disable this();
	deprecated("Use matrixStack() instead.") pure nothrow this(size_t depth)
	{
		stack = new Matrix[](depth);
	}
	pure nothrow void set(Matrix matrix)
	{
		top = matrix;
	}
	pure nothrow void push()
	{
		if (stack.length <= _top_pos)
		{
			stack.length += realloc_interval;
		}
		stack[_top_pos++] = top;
	}
	pure nothrow void push(Matrix matrix)
	{
		push();
		top = matrix;
	}
	pure nothrow ref Matrix pop()
	in
	{
		assert(_top_pos >= 1, "popped too often from matrix stack");
	}
	do
	{
		top = stack[--_top_pos];
		return top;
	}
}
pure nothrow MatrixStack!T matrixStack(T)(size_t depth = 16)
{
	typeof(return) res = MatrixStack!T.init;
	res.stack.length = depth;
	return res;
}
