// D import file generated from 'gl3n/frustum.d'
module gl3n.frustum;
private 
{
	import gl3n.linalg : vec3, mat4, dot;
	import gl3n.math : abs, cradians;
	import gl3n.aabb : AABB;
	import gl3n.plane : Plane;
}
enum 
{
	OUTSIDE = 0,
	INSIDE,
	INTERSECT,
}
struct Frustum
{
	enum 
	{
		LEFT,
		RIGHT,
		BOTTOM,
		TOP,
		NEAR,
		FAR,
	}
	Plane[6] planes;
	nothrow pure @safe 
	{
		@property ref Plane left();
		@property ref Plane right();
		@property ref Plane bottom();
		@property ref Plane top();
		@property ref Plane near();
		@property ref Plane far();
		this(mat4 mvp)
		{
			mvp.transpose();
			planes = [Plane(mvp[0][3] + mvp[0][0], mvp[1][3] + mvp[1][0], mvp[2][3] + mvp[2][0], mvp[3][3] + mvp[3][0]), Plane(mvp[0][3] - mvp[0][0], mvp[1][3] - mvp[1][0], mvp[2][3] - mvp[2][0], mvp[3][3] - mvp[3][0]), Plane(mvp[0][3] + mvp[0][1], mvp[1][3] + mvp[1][1], mvp[2][3] + mvp[2][1], mvp[3][3] + mvp[3][1]), Plane(mvp[0][3] - mvp[0][1], mvp[1][3] - mvp[1][1], mvp[2][3] - mvp[2][1], mvp[3][3] - mvp[3][1]), Plane(mvp[0][3] + mvp[0][2], mvp[1][3] + mvp[1][2], mvp[2][3] + mvp[2][2], mvp[3][3] + mvp[3][2]), Plane(mvp[0][3] - mvp[0][2], mvp[1][3] - mvp[1][2], mvp[2][3] - mvp[2][2], mvp[3][3] - mvp[3][2])];
			normalize();
		}
		this(Plane[6] planes)
		{
			this.planes = planes;
			normalize();
		}
		private void normalize();
		int intersects(AABB aabb);
		bool opBinaryRight(string s : "in")(AABB aabb)
		{
			return intersects(aabb) > 0;
		}
	}
}
